(* print_pnt - translates /proc/net/tcp to human-readable form
   
   (C) 2002 Nicholas Jay Kain <niklata@aerifal.cx>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation. 

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*)

open Proctcp

let print_tcp tcp =
  print_string "\nServer IP: " ; print_string tcp.s_ip ;
  print_string "\nServer Port: " ; print_int tcp.s_port ;
  print_string "\nDest IP: " ; print_string tcp.d_ip ;
  print_string "\nDest Port: " ; print_int tcp.d_port ;
  print_string "\nUID: " ; print_int tcp.uid ;
  print_string "\n"
;;

let rec print_tcp_list = function
    [] -> ()
  | h::t -> print_tcp h ; print_tcp_list t ; ()
;;

let a = read_pnt (proc_net_tcp) in
print_tcp_list a ;;
