open Conntrack ;;

let string_of_proto = function
    UDP -> "UDP"
  | TCP -> "TCP"
  | ICMP -> "ICMP"
;;

let string_of_state = function
    NONE -> "NONE"
  | ESTABLISHED -> "ESTABLISHED"
  | SYN_SENT -> "SYN_SENT"
  | SYN_RECV -> "SYN_RECV"
  | FIN_WAIT -> "FIN_WAIT"
  | TIME_WAIT -> "TIME_WAIT"
  | CLOSE -> "CLOSE"
  | CLOSE_WAIT -> "CLOSE_WAIT"
  | LAST_ACK -> "LAST_ACK"
  | LISTEN -> "LISTEN"
;;

let string_of_assure = function
    ASSURED -> "ASSURED"
  | UNREPLIED -> "UNREPLIED"
  | UNSPECIFIED -> "UNSPECIFIED"
;;

let print_conn_t ct = 
  print_string ("\nProto: " ^ (string_of_proto ct.proto)) ;
  print_string ("\nUnknown1: " ^ (string_of_int ct.unknown1)) ;
  print_string ("\nUnknown2: " ^ (string_of_int ct.unknown2)) ;
  print_string ("\nState: " ^ (string_of_state ct.state)) ;
  print_string ("\nReal SIP: " ^ (Unix.string_of_inet_addr ct.r_src) ^ ":" ^ (string_of_int ct.r_sport)) ;
  print_string ("\nReal DIP: " ^ (Unix.string_of_inet_addr ct.r_dst) ^ ":" ^ (string_of_int ct.r_dport)) ;
  print_string ("\nTranslated SIP: " ^ (Unix.string_of_inet_addr ct.t_src) ^ ":" ^ (string_of_int ct.t_sport)) ;
  print_string ("\nTranslated DIP: " ^ (Unix.string_of_inet_addr ct.t_dst) ^ ":" ^ (string_of_int ct.t_dport)) ;
  print_string ("\nTransience: " ^ (string_of_assure ct.assure)) ;
  print_string ("\nUse: " ^ (string_of_int ct.use)) ;
  print_string ("\n")
;;

let rec print_conn_t_list = function
    [] -> ()
  | h::t -> print_conn_t h ; print_conn_t_list t
;;

let gather_and_print =
  print_conn_t_list read_conntrack
;;
